"{ Package: 'stx:goodies/regression' }"

"{ NameSpace: RegressionTests }"

TestCase subclass:#QDoubleTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'tests-Regression-Numbers'
!

!QDoubleTests class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
	cg

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!QDoubleTests methodsFor:'tests'!

test_01_instance_creation
    |q|

    q := QDouble fromFloat:1.0.
    self assert:(q d0 = 1.0).
    self assert:(q d1 = 0.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := QDouble fromInteger:1.
    self assert:(q d0 = 1.0).
    self assert:(q d1 = 0.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1 asQDouble.
    self assert:(q d0 = 1.0).
    self assert:(q d1 = 0.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1.0 asQDouble.
    self assert:(q d0 = 1.0).
    self assert:(q d1 = 0.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1e40 asQDouble + 1.0 asQDouble.
    self assert:(q d0 = 1e40).
    self assert:(q d1 = 1.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1e40 asQDouble + 1.0.
    self assert:(q d0 = 1e40).
    self assert:(q d1 = 1.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1e120 asQDouble + 1e40 + 1.0.
    self assert:(q d0 = 1e120).
    self assert:(q d1 = 1e40).
    self assert:(q d2 = 1.0).
    self assert:(q d3 = 0.0).

    q := 1e200 asQDouble + 1e120 + 1e40 + 1.0.
    self assert:(q d0 = 1e200).
    self assert:(q d1 = 1e120).
    self assert:(q d2 = 1e40).
    self assert:(q d3 = 1.0).

    "
     self run:#test_01_instance_creation
     self new test_01_instance_creation
    "

    "Created: / 12-06-2017 / 17:03:46 / cg"
    "Modified: / 20-06-2017 / 07:48:51 / cg"
    "Modified: / 05-06-2019 / 20:15:30 / Claus Gittinger"
!

test_02_addition
    |d1 d2 l1 l2 sum_l q1 q2 sum_d sum_q|

    d1 := 1.0.
    d2 := 1.0e-16.
    sum_d := d1 + d2.
    "/ precision is lost with doubles!!
    self assert:( sum_d - 1.0 = 0.0 ).

    l1 := 1.0 asLongFloat.
    l2 := 1.0e-16 asLongFloat.
    sum_l := l1 + l2.
    "/ no precision is lost with long doubles!!
    self assert:( (sum_l - (1.0 asLongFloat)) > 0.0 ).

    l1 := 1.0 asLongFloat.
    l2 := 1.0e-30 asLongFloat.
    sum_l := l1 + l2.
    "/ precision is lost!!
    self assert:( (sum_l - (1.0 asLongFloat)) = 0.0 ).

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:1.0e-16.
    sum_q := q1 + q2.

    "/ no precision is lost with qDoubles
    self assert:( (sum_q - (QDouble fromFloat:1.0)) > 0.0 ).
    self assert:( (sum_q - (QDouble fromFloat:1.0)) = 1.0e-16 ).

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:1.0e-30.
    sum_q := q1 + q2.

    "/ no precision is lost with qDoubles
    self assert:( (sum_q - (QDouble fromFloat:1.0)) > 0.0 ).
    self assert:( (sum_q - (QDouble fromFloat:1.0)) = 1.0e-30 ).

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:2.0.
    sum_q := q1 + q2.
    self assert:( sum_q = 3.0 ).

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:2.0.
    sum_q := q1 + 2.0.
    self assert:( sum_q = 3.0 ).

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:2.0.
    sum_q := 1.0 + q2.
    self assert:( sum_q = 3.0 ).

    q1 := 1e200 asQDouble + 1e120 + 1e40 + 1.0.
    q2 := 1e120.
    sum_q := q1 + q2.
    self assert:(sum_q d0 = 1e200).
    self assert:(sum_q d1 = 2e120).
    self assert:(sum_q d2 = 1e40).
    self assert:(sum_q d3 = 1.0).

    '%.60f' printf:{QDouble pi}

    "
     self run:#test_02_addition
     self new test_02_addition
    "

    "Created: / 12-06-2017 / 17:05:07 / cg"
    "Modified: / 20-06-2017 / 07:49:32 / cg"
    "Modified: / 05-06-2019 / 20:15:38 / Claus Gittinger"
!

test_02b_addition
    |q1 q2 sum_q|

    q1 := 1.0e20 asQDouble.
    q2 := 1.0e-16 asQDouble.
    sum_q := q1 + q2.
    self assert:( sum_q - q1 = q2 ).
    self assert:( sum_q - q2 = q1 ).

    sum_q := sum_q + 1e-30.
    self assert:( sum_q - q1 -q2 = 1e-30 ).

    sum_q := sum_q + 1e10.
    self assert:( sum_q - q1 - q2 - 1e10 = 1e-30 ).
    self assert:( sum_q - q1 - q2 - 1e-30 = 1e10 ).

    "
     self run:#test_02b_addition
     self new test_02b_addition
    "
!

test_03_subtract
    |d1 d2 l1 l2 diff_l q1 q2 diff_d diff_q|

    d1 := 1.0.
    d2 := 0.99999.
    diff_d := d1 - d2.
    "/ precision is lost with doubles!!

    l1 := 1.0 asLongFloat.
    l2 := 0.99999 asLongFloat.
    diff_l := l1 - l2.
    "/ no precision is lost with long doubles!!

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:0.99999.

    diff_q := q1 - q2.

    "
     self run:#test_03_subtract
     self new test_03_subtract
    "

    "Created: / 12-06-2017 / 23:12:00 / cg"
    "Modified: / 05-06-2019 / 20:16:12 / Claus Gittinger"
!

test_04_relops

    self assert:(1.0 = 1.0 asQDouble).
    self assert:(1.0 asQDouble = 1.0).
    self assert:(1.0 asQDouble = 1.0 asQDouble).

    self assert:(1 = 1 asQDouble).
    self assert:(1 asQDouble = 1).
    self assert:(1 asQDouble = 1 asQDouble).

    self assert:(1 = 1.0 asQDouble).
    self assert:(1.0 asQDouble = 1).
    self assert:(1.0 asQDouble = 1 asQDouble).

    self assert:(1.0 = 1 asQDouble).
    self assert:(1 asQDouble = 1.0).
    self assert:(1 asQDouble = 1.0 asQDouble).


    self deny:(1.0 = 1.1 asQDouble).
    self deny:(1.0 asQDouble = 1.1).
    self deny:(1.0 asQDouble = 1.1 asQDouble).

    self deny:(1 = 2 asQDouble).
    self deny:(1 asQDouble = 2).
    self deny:(1 asQDouble = 2 asQDouble).

    self deny:(1 = 2.0 asQDouble).
    self deny:(1.0 asQDouble = 2).
    self deny:(1.0 asQDouble = 2 asQDouble).

    self deny:(2.0 = 1 asQDouble).
    self deny:(2 asQDouble = 1.0).
    self deny:(2 asQDouble = 1.0 asQDouble).



    self assert:(1.0 < 1.1 asQDouble).
    self assert:(1.0 asQDouble < 1.1).
    self assert:(1.0 asQDouble < 1.1 asQDouble).

    self assert:(1 < 2 asQDouble).
    self assert:(1 asQDouble < 2).
    self assert:(1 asQDouble < 2 asQDouble).

    self assert:(1 < 2.0 asQDouble).
    self assert:(1.0 asQDouble < 2).
    self assert:(1.0 asQDouble < 2 asQDouble).

    self assert:(1.0 < 2 asQDouble).
    self assert:(1 asQDouble < 2.0).
    self assert:(1 asQDouble < 2.0 asQDouble).


    self deny:(1.0 < 1.0 asQDouble).
    self deny:(1.0 asQDouble < 1.0).
    self deny:(1.0 asQDouble < 1.0 asQDouble).

    self deny:(1 < 1 asQDouble).
    self deny:(1 asQDouble < 1).
    self deny:(1 asQDouble < 1 asQDouble).

    self deny:(1 < 1.0 asQDouble).
    self deny:(1.0 asQDouble < 1).
    self deny:(1.0 asQDouble < 1 asQDouble).

    self deny:(1.0 < 1 asQDouble).
    self deny:(1 asQDouble < 1.0).
    self deny:(1 asQDouble < 1.0 asQDouble).



    self assert:(2.0 > 1.1 asQDouble).
    self assert:(2.0 asQDouble > 1.1).
    self assert:(2.0 asQDouble > 1.1 asQDouble).

    self assert:(3 > 2 asQDouble).
    self assert:(3 asQDouble > 2).
    self assert:(3 asQDouble > 2 asQDouble).

    self assert:(3 > 2.0 asQDouble).
    self assert:(3.0 asQDouble > 2).
    self assert:(3.0 asQDouble > 2 asQDouble).

    self assert:(3.0 > 2 asQDouble).
    self assert:(3 asQDouble > 2.0).
    self assert:(3 asQDouble > 2.0 asQDouble).


    self deny:(1.0 > 3.0 asQDouble).
    self deny:(1.0 asQDouble > 3.0).
    self deny:(1.0 asQDouble > 3.0 asQDouble).

    self deny:(1 > 3 asQDouble).
    self deny:(1 asQDouble > 3).
    self deny:(1 asQDouble > 3 asQDouble).

    self deny:(1 > 3.0 asQDouble).
    self deny:(1.0 asQDouble > 3).
    self deny:(1.0 asQDouble > 3 asQDouble).

    self deny:(1.0 > 3 asQDouble).
    self deny:(1 asQDouble > 3.0).
    self deny:(1 asQDouble > 3.0 asQDouble).


    self assert:(1.0 <= 3.0 asQDouble).
    self assert:(1.0 asQDouble <= 3.0).
    self assert:(1.0 asQDouble <= 3.0 asQDouble).

    self assert:(1.0 <= 1.0 asQDouble).
    self assert:(1.0 asQDouble <= 1.0).
    self assert:(1.0 asQDouble <= 1.0 asQDouble).

    self assert:(2.0 >= 1.0 asQDouble).
    self assert:(2.0 asQDouble >= 1.0).
    self assert:(2.0 asQDouble >= 1.0 asQDouble).

    self assert:(1.0 >= 1.0 asQDouble).
    self assert:(1.0 asQDouble >= 1.0).
    self assert:(1.0 asQDouble >= 1.0 asQDouble).



    self assert: ((1.0 asQDouble + 1e-40) > 1.0 asQDouble).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-40)).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-80)).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-120)).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-300)).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-300)).

    self assert: ((1.0 asQDouble + 1e-40) > 1.0).
    self assert: (1.0 < (1.0 asQDouble + 1e-40)).
    self assert: (1.0 < (1.0 asQDouble + 1e-80)).
    self assert: (1.0 < (1.0 asQDouble + 1e-120)).
    self assert: (1.0 < (1.0 asQDouble + 1e-300)).
    self assert: (1.0 < (1.0 asQDouble + 1e-308)).

    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-40) ).
    self assert: ((1.0 asQDouble + 1e-40) > 1.0 asQDouble ).
    self assert: ((1.0 asQDouble + 1e-80) > 1.0 asQDouble ).
    self assert: ((1.0 asQDouble + 1e-120) > 1.0 asQDouble ).
    self assert: ((1.0 asQDouble + 1e-300) > 1.0 asQDouble ).
    self assert: ((1.0 asQDouble + 1e-308) > 1.0 asQDouble ).

    self assert: ((1.0 asQDouble + 1e-40) > 1.0).
    self assert: (1.0 < (1.0 asQDouble + 1e-40)).
    self assert: (1.0 < (1.0 asQDouble + 1e-80)).
    self assert: (1.0 < (1.0 asQDouble + 1e-120)).
    self assert: (1.0 < (1.0 asQDouble + 1e-300)).
    self assert: (1.0 < (1.0 asQDouble + 1e-300)).

    self assert: (1.0  < (1.0 asQDouble + 1e-40) ).
    self assert: ((1.0 asQDouble + 1e-40) > 1.0  ).
    self assert: ((1.0 asQDouble + 1e-80) > 1.0  ).
    self assert: ((1.0 asQDouble + 1e-120) > 1.0  ).
    self assert: ((1.0 asQDouble + 1e-300) > 1.0  ).
    self assert: ((1.0 asQDouble + 1e-308) > 1.0  ).

    self assert: (1e10 asQDouble + 1.0) = 10000000001.0.
    "/ that's the problem with Floats...
    "/ (1e20 asQDouble + 1.0) ~= 100000000000000000001.0.
    "/ (1e20 + 1.0) - 1e20 ~= 1.0.
    self assert: (1e20 asQDouble + 1.0) - 1e20 = 1.0.

    "/ here the precision of QDOubles is no longer enough:
    "/ self assert:  1.0 asQDouble < (1.0 asQDouble + 1e-310).

    "
     self run:#test_03_subtract
     self new test_03_subtract
    "

    "Created: / 13-06-2017 / 17:11:37 / cg"
    "Modified (comment): / 20-06-2017 / 09:18:50 / cg"
    "Modified: / 05-06-2019 / 20:16:21 / Claus Gittinger"
!

test_05_multiply
    |q1 q2 p|

    q1 := QDouble fromFloat:3.0. "/ DoubleArray(2.0 0.0 0.0 0.0)
    p := 2.0 * q1.

    self assert:(p d0 = 6.0).
    self assert:(p d1 = 0.0).
    self assert:(p d2 = 0.0).
    self assert:(p d3 = 0.0).
    self assert:(p = 6.0).
    self assert:(6.0 = p).

    q1 := QDouble fromFloat:2.0. "/ DoubleArray(2.0 0.0 0.0 0.0)
    p := q1 * 3.0.

    self assert:(p d0 = 6.0).
    self assert:(p d1 = 0.0).
    self assert:(p d2 = 0.0).
    self assert:(p d3 = 0.0).
    self assert:(p = 6.0).
    self assert:(6.0 = p).

    q1 := QDouble fromFloat:2.0. "/ DoubleArray(2.0 0.0 0.0 0.0)
    q2 := QDouble fromFloat:3.0. "/ DoubleArray(3.0 0.0 0.0 0.0)
    p := q1 * q2.

    self assert:(p d0 = 6.0).
    self assert:(p d1 = 0.0).
    self assert:(p d2 = 0.0).
    self assert:(p d3 = 0.0).
    self assert:(p = 6.0).
    self assert:(6.0 = p).

    "/ the 1 is not forgotten!!
    q1 := 1 asQDouble + 1e40.
    q2 := 2.0.
    p := q1 * q2.

    self assert:(p d0 = 2e40).
    self assert:(p d1 = 2.0).
    self assert:(p d2 = 0.0).
    self assert:(p d3 = 0.0).
    self assert:(p > 2e40).
    self assert:(p - 2e40) = 2.0.

    "/ nothing is forgotten!!
    q1 := 1 asQDouble + 1e40 + 1e120.
    q2 := 2.0.
    p := q1 * q2.

    self assert:(p d0 = 2e120).
    self assert:(p d1 = 2e40).
    self assert:(p d2 = 2.0).
    self assert:(p d3 = 0.0).
    self assert:(p > 2e120).
    self assert:(p > (2e120 asQDouble + 2)).
    self assert:(p > (2e120 asQDouble + 1e40)).
    self assert:(p - 2e120) = (2 asQDouble + 2e40).
    self assert:(p - 2e120 - 2e40) = 2.0.

    "
     self run:#test_05_multiply
     self new test_05_multiply
    "

    "Created: / 19-06-2017 / 16:58:29 / cg"
    "Modified (comment): / 20-06-2017 / 07:42:52 / cg"
    "Modified: / 05-06-2019 / 20:16:30 / Claus Gittinger"
!

test_06_exp
    |f1 q1|

    f1 := 2.0 exp.
    q1 := 2.0 asQDouble exp.
    self assert:(q1 d0 - f1) abs < 0.00000001.

    "/ the first 113 digits are (wolfram):
    "/    7.3890560989306502272304274605750078131803155705518473240871278225225737960790577633843124850791217947737531612654...
    "/ 2.0 exp
    "/    7.38905609893065
    "/ 2.0QD exp
    "/    7.389056098930650227230427460575
    "/ 2.0QD exp printfPrintString:'%.60f'
    "/    7.389056098930650227230427460575007813180315570551847324087128

    f1 := 3.0 exp.
    q1 := 3.0 asQDouble exp.
    self assert:(q1 d0 - f1) abs < 0.00000001.

    "/ the first 113 digits are (wolfram):
    "/    20.0855369231876677409285296545817178969879078385541501443789342296988458780919737312044971602530177021536076158519...
    "/ 3.0 exp
    "/    20.0855369231877
    "/ 3.0QD exp
    "/    20.08553692318766774092852965458
    "/ 3.0QD exp printfPrintString:'%.60f'
    "/    20.085536923187667740928529654581717896987907838554150144378934


    f1 := 0.5 exp.
    q1 := 0.5 asQDouble exp.
    self assert:(q1 d0 - f1) abs < 0.00000001.

    "/ the first digits are (wolfram):
    "/    1.648721270700128146848650787814163571653776100710148011575...
    "/ 0.5 exp
    "/    1.64872127070013
    "/ 0.5QD exp
    "/    1.648721270700128146848650787814
    "/ 0.5QD exp printfPrintString:'%.60f'
    "/    1.648721270700128146848650787814163571653776100710148011575079

    f1 := -1.0 exp.
    q1 := -1.0 asQDouble exp.
    self assert:(q1 d0 - f1) abs < 0.00000001.

    f1 := -3.0 exp.
    q1 := -3.0 asQDouble exp.
    self assert:(q1 d0 - f1) abs < 0.00000001.


"/    1.0 exp  -> 2.71828182845905
"/    1.0 asQDouble exp  2.718281828459045235360287471353
"/    1.0 exp asQDouble  2.718281828459045090795598298428
"/
"/    3.0 ln  -> 1.09861228866811
"/    3.0 asQDouble ln 8.148220079427205481478375773976
"/    3.0 ln asQDouble  1.098612288668109782108217586938
"/
"/    1.0 exp ln -> 1.0
"/    1.0 exp ln asQDouble  -> 1.0
"/    1.0 asQDouble exp ln     6.316187310732210430808896199868
"/    1.0 exp asQDouble ln     6.316187310732210132396290848094
"/
"/    f1 := 100 exp asQDouble 2.68811714181614E+.

    f1 := 100 exp.
    q1 := 100 asQDouble exp.
    "/ self assert:(q1 d0 - f1) abs < 0.00000001.

    "/ the first digits are (wolfram):
    "/    2.688117141816135448412625551580013587361111877374192241519160861528028703490956491415887109721984571081167087...  10^43
    "/ 100 exp
    "/    2.688117141816135448E+43
    "/ 100QD exp
    "/    2.6881171418161354 109477678826e43
    "/ 100QD exp printfPrintString:'%2.60g'
    "/    2.688117141816135410947767882599577473393902466198400202846738e43'

    "
     self run:#test_06_exp
     self new test_06_exp
    "

    "Created: / 19-06-2017 / 17:58:08 / cg"
    "Modified (comment): / 21-06-2017 / 13:45:56 / cg"
    "Modified: / 05-06-2019 / 20:16:35 / Claus Gittinger"
!

test_06b_log10
    |q1 q2 d3a q3a d3b q3b q4 i|

    "/ 5.5...e-18
    q1 := QDouble d0: 5.55111512312578E-18
		  d1: -3.08148791101958E-34
		  d2: 1.71056941445901E-50
		  d3: 0.0.

    q2 := 10 / q1.
    self assert:(q2 > 1e18).

    d3a := q2 asFloat ln.
    self assert:(d3a isNaN not).

    q3a := q2 ln.
    self assert:(q3a isNaN not).

    d3b := q2 asFloat log10.
    self assert:(d3b isNaN not).

    q3b := q2 log10.
    self assert:(q3b isNaN not).

    q4 := q3b floor.
    i := q4 asInteger.

    self assert:(1.0 asQDouble ln = 0.0).
    self assert:(QDouble e ln - 1.0) < (2*QDouble epsilon).
    self assert:(QDouble e squared ln - 2.0) < (2*QDouble epsilon).

    self assert:(1.0 asQDouble log10 = 0.0).
    self assert:(10.0 asQDouble log10 - 1.0) < (2*QDouble epsilon).
    self assert:(10000.0 asQDouble log10 - 5.0) < (2*QDouble epsilon).
    self assert:(1e20 asQDouble log10 - 20.0) < (2*QDouble epsilon).
    self assert:(1e-20 asQDouble log10 + 20.0) < (2*QDouble epsilon).

    "/ nope: too inaccurate
    "/ self assert:(1e-100 asQDouble log10 + 100.0) < (2*QDouble epsilon).

    "/ QDouble fmax abs log10 floor asInteger.

    "
     self run:#test_06b_log10
     self new test_06b_log10
    "

    "Created: / 03-07-2017 / 10:31:53 / cg"
    "Modified: / 05-06-2019 / 20:18:26 / Claus Gittinger"
!

test_06c_exp
    |f1 q1 f2 q2 f3 q3|

    f1 := 3.0 ln.
    q1 := 3.0 ln asQDouble.
    self assert:(q1 - f1) abs < 0.0001.

    f2 := f1 negated.
    q2 := q1 negated.
    self assert:(q2 - f2) abs < 0.0001.

    f3 := f2 exp.
    q3 := q2 exp.
    self assert:(q3 - f3) abs < 0.0001.

    "
     self run:#test_06c_exp
     self new test_06c_exp
    "
!

test_07_reading
    |q1 s|

    q1 := QDouble readFrom: '3.1415926535897'.
    s := '%55.54f' printf:{ q1 }.
    self assert:(s = '                                        3.1415926535897').

    q1 := QDouble readFrom: '3.141592653589793238462643383'.
    s := '%55.54f' printf:{ q1 }.
    self assert:(s = '                          3.141592653589793238462643383').

    q1 := QDouble readFrom: '3.141592653589793238462643383279502884197169399375105820'.
    s := '%55.54f' printf:{ q1 }.
    self assert:(s = '3.14159265358979323846264338327950288419716939937510582').

    "
     self run:#test_07_reading
     self new test_07_reading
    "

    "Created: / 19-06-2017 / 23:29:34 / cg"
    "Modified: / 05-06-2019 / 20:18:51 / Claus Gittinger"
!

test_08_conversion
    |q i|

    q := 1e10 asQDouble + 1.0.
    i := q asInteger.

    self assert:(i = 10000000001).

    "
     self run:#test_08_conversion
     self new test_08_conversion
    "

    "Created: / 20-06-2017 / 07:51:50 / cg"
    "Modified: / 05-06-2019 / 20:18:48 / Claus Gittinger"
!

test_09_truncatingAndRounding
    self assert:(1.0 truncatedAsFloat = 1.0).
    self assert:(1.0 asQDouble truncatedAsFloat = 1.0 asQDouble).
    self assert:(1.0 asQDouble truncatedAsFloat = 1.0).

    self assert:(1.1 truncatedAsFloat = 1.0).
    self assert:(1.1 asQDouble truncatedAsFloat = 1.0 asQDouble).
    self assert:(1.1 asQDouble truncatedAsFloat = 1.0).

    self assert:(1.999 truncatedAsFloat = 1.0).
    self assert:(1.999 asQDouble truncatedAsFloat = 1.0 asQDouble).
    self assert:(1.999 asQDouble truncatedAsFloat = 1.0).

    self assert:(-1.999 truncatedAsFloat = -1.0).
    self assert:(-1.999 asQDouble truncatedAsFloat = -1.0 asQDouble).
    self assert:(-1.999 asQDouble truncatedAsFloat = -1.0).

    self assert:(1.0 truncated == 1).
    self assert:(1.0 asQDouble truncated == 1).
    self assert:(1.0 asQDouble truncated == 1).

    self assert:(1.1 truncated == 1).
    self assert:(1.1 asQDouble truncated == 1).
    self assert:(1.1 asQDouble truncated == 1).

    self assert:(1.999 truncated == 1).
    self assert:(1.999 asQDouble truncated == 1).
    self assert:(1.999 asQDouble truncated == 1).

    self assert:(-1.999 truncated == -1).
    self assert:(-1.999 asQDouble truncated == -1).
    self assert:(-1.999 asQDouble truncated == -1).

    "/ ---------
    self assert:(1.0 floorAsFloat = 1.0).
    self assert:(1.0 asQDouble floorAsFloat = 1.0 asQDouble).
    self assert:(1.0 asQDouble floorAsFloat = 1.0).

    self assert:(1.1 floorAsFloat = 1.0).
    self assert:(1.1 asQDouble floorAsFloat = 1.0 asQDouble).
    self assert:(1.1 asQDouble floorAsFloat = 1.0).

    self assert:(1.999 floorAsFloat = 1.0).
    self assert:(1.999 asQDouble floorAsFloat = 1.0 asQDouble).
    self assert:(1.999 asQDouble floorAsFloat = 1.0).

    self assert:(-1.999 floorAsFloat = -2.0).
    self assert:(-1.999 asQDouble floorAsFloat = -2.0 asQDouble).
    self assert:(-1.999 asQDouble floorAsFloat = -2.0).

    self assert:(1.0 floor == 1).
    self assert:(1.0 asQDouble floor == 1).
    self assert:(1.0 asQDouble floor == 1).

    self assert:(1.1 floor == 1).
    self assert:(1.1 asQDouble floor == 1).
    self assert:(1.1 asQDouble floor == 1).

    self assert:(1.999 floor == 1).
    self assert:(1.999 asQDouble floor == 1).
    self assert:(1.999 asQDouble floor == 1).

    self assert:(-1.999 floor == -2).
    self assert:(-1.999 asQDouble floor == -2).
    self assert:(-1.999 asQDouble floor == -2).

    "/ -------
    self assert:(1.0 ceilingAsFloat = 1.0).
    self assert:(1.0 asQDouble ceilingAsFloat = 1.0 asQDouble).
    self assert:(1.0 asQDouble ceilingAsFloat = 1.0).

    self assert:(1.1 ceilingAsFloat = 2.0).
    self assert:(1.1 asQDouble ceilingAsFloat = 2.0 asQDouble).
    self assert:(1.1 asQDouble ceilingAsFloat = 2.0).

    self assert:(1.999 ceilingAsFloat = 2.0).
    self assert:(1.999 asQDouble ceilingAsFloat = 2.0 asQDouble).
    self assert:(1.999 asQDouble ceilingAsFloat = 2.0).

    self assert:(-1.999 ceilingAsFloat = -1.0).
    self assert:(-1.999 asQDouble ceilingAsFloat = -1.0 asQDouble).
    self assert:(-1.999 asQDouble ceilingAsFloat = -1.0).

    self assert:(1.0 ceiling == 1).
    self assert:(1.0 asQDouble ceiling == 1).
    self assert:(1.0 asQDouble ceiling == 1).

    self assert:(1.1 ceiling == 2).
    self assert:(1.1 asQDouble ceiling == 2).
    self assert:(1.1 asQDouble ceiling == 2).

    self assert:(1.999 ceiling == 2).
    self assert:(1.999 asQDouble ceiling == 2).
    self assert:(1.999 asQDouble ceiling == 2).

    self assert:(-1.999 ceiling == -1).
    self assert:(-1.999 asQDouble ceiling == -1).
    self assert:(-1.999 asQDouble ceiling == -1).

    "/ ---------
    self assert:(1.0 roundedAsFloat = 1.0).
    self assert:(1.0 asQDouble roundedAsFloat = 1.0 asQDouble).
    self assert:(1.0 asQDouble roundedAsFloat = 1.0).

    self assert:(1.1 roundedAsFloat = 1.0).
    self assert:(1.1 asQDouble roundedAsFloat = 1.0 asQDouble).
    self assert:(1.1 asQDouble roundedAsFloat = 1.0).

    self assert:(1.999 roundedAsFloat = 2.0).
    self assert:(1.999 asQDouble roundedAsFloat = 2.0 asQDouble).
    self assert:(1.999 asQDouble roundedAsFloat = 2.0).

    self assert:(1.499 roundedAsFloat = 1.0).
    self assert:(1.499 asQDouble roundedAsFloat = 1.0 asQDouble).
    self assert:(1.499 asQDouble roundedAsFloat = 1.0).

    self assert:(1.5 roundedAsFloat = 2.0).
    self assert:(1.5 asQDouble roundedAsFloat = 2.0 asQDouble).
    self assert:(1.5 asQDouble roundedAsFloat = 2.0).

    self assert:(-1.999 roundedAsFloat = -2.0).
    self assert:(-1.999 asQDouble roundedAsFloat = -2.0 asQDouble).
    self assert:(-1.999 asQDouble roundedAsFloat = -2.0).

    self assert:(-1.499 roundedAsFloat = -1.0).
    self assert:(-1.499 asQDouble roundedAsFloat = -1.0 asQDouble).
    self assert:(-1.499 asQDouble roundedAsFloat = -1.0).

    self assert:(-1.5 roundedAsFloat = -2.0).
    self assert:(-1.5 asQDouble roundedAsFloat = -2.0 asQDouble).
    self assert:(-1.5 asQDouble roundedAsFloat = -2.0).

    self assert:(1.0 rounded == 1).
    self assert:(1.0 asQDouble rounded == 1).

    self assert:(1.1 rounded == 1).
    self assert:(1.1 asQDouble rounded == 1).

    self assert:(1.999 rounded == 2).
    self assert:(1.999 asQDouble rounded == 2).

    self assert:(1.499 rounded == 1).
    self assert:(1.499 asQDouble rounded == 1).

    self assert:(1.5 rounded == 2).
    self assert:(1.5 asQDouble rounded == 2).

    self assert:(-1.999 rounded == -2).
    self assert:(-1.999 asQDouble rounded == -2).

    self assert:((-1.6 roundTo:0.5) = -1.5).
    self assert:((-1.6 asQDouble roundTo:0.5) = -1.5).
    self assert:((-1.6 asQDouble roundTo:0.5) = -1.5 asQDouble).


    "
     self run:#test_09_truncatingAndRounding
     self new test_09_truncatingAndRounding
    "
!

test_10_printing
    "/ 1.0001 asQDouble printString.

    self assert:(1.0 asQDouble printString = 1.0 printString).
    self assert:(1.0 asQDouble printString = '1.0').
    self assert:(-1.0 asQDouble printString = -1.0 printString).
    self assert:(-1.0 asQDouble printString = '-1.0').


    "/ self assert:(1.125QD printString = 1.125 printString).
    self assert:(1.125 asQDouble printString = '1.125').
    self assert:(-1.125 asQDouble printString = -1.125 printString).
    self assert:(-1.125 asQDouble printString = '-1.125').

    "/ loose bits in double prec.: (1e10 + 1) - 1e10  -> 1.0
    "/ loose bits in double prec.: (1e20 + 1) - 1e20  -> 0.0
    self assert:((1e20 asQDouble + 1) - 1e20) = 1.0.
    self assert:(((1e20 asQDouble + 1) - 1e20) printString = '1.0').
    self assert:((1e40 asQDouble + 1) - 1e40) = 1.0.
    self assert:(((1e40 asQDouble + 1) - 1e40) printString = '1.0').

    self assert:((1e40 asQDouble + 1 + 1e-40) - 1e40 - 1) = 1e-40.
    self assert:((1e40 asQDouble + 1 + 1e-40) + 1e-40 - 1e40 - 1) = 2e-40.

    "
     self run:#test_10_printing
     self new test_10_printing
    "
!

test_11a_pi
    "/ Machin's Formula for Pi pi / 4  =  4 arctan(1/5) - arctan(1/239)

    | at1_5 at1_239 pi_4 pi err|

    at1_5 := (1 asQDouble / 5) arcTan.
    at1_239 := (1 asQDouble / 239) arcTan.
    pi_4 := (at1_5 * 4) - at1_239.
    pi := pi_4 * 4.
    err := QDouble pi - pi.
    self assert:(err < (8 * QDouble epsilon)).
!

test_11b_pi
    "/ Salamin-Brent Quadratic Formula for Pi

    | max_iter a b s m a_new b_new p_old pi err|

    max_iter := 6.

    a := 1.0 asQDouble.
    b := 0.5 asQDouble sqrt.
    s := 0.5 asQDouble.
    m := 1.0 asQDouble.

    pi := 2.0 asQDouble * a squared / s.
    1 to:max_iter do:[:i |
	m := m * 2.
	a_new := 0.5 * (a+b).
	b_new := a * b.
	s := s - (m * (a_new squared - b_new)).
	a := a_new.
	b := b_new sqrt.
	p_old := pi.
	pi := 2 * a squared / s.
    ].

    err := QDouble pi - pi.
    self assert:(err < (8 * QDouble epsilon)).
!

test_12_e
    "/ Taylor for e

    | e t n i err|

    e := 2.0 asQDouble.
    t := 1.0 asQDouble.
    n := 1.0.
    i := 0.

    [t > QDouble epsilon] whileTrue:[
	i := i + 1.
	n := n + 1.0.
	t := t / n.
	e := e + t.
    ].

    err := QDouble e - e.
    self assert:(err < (8 * QDouble epsilon)).
! !

!QDoubleTests class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

